import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.Random;
import javax.imageio.ImageIO;
import javax.swing.*;

public class Main {
    public static void main(String[] args) throws IOException {
        JFrame TankFrame = new JFrame();
        JPanel TankPanel = new JPanel();

        TankFrame.setLayout(new BorderLayout());
        TankFrame.setSize(900, 500);
        TankFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        TankFrame.setLayout(new BorderLayout(1,1));

        DrawningTank DrawningTank = new DrawningTank();

        TankPanel.setLayout(null);

        BufferedImage RightIcon = ImageIO.read(new File("resources/RightButton.png"));
        BufferedImage LeftIcon = ImageIO.read(new File("resources/LeftButton.png"));
        BufferedImage UpIcon = ImageIO.read(new File("resources/UpButton.png"));
        BufferedImage DownIcon = ImageIO.read(new File("resources/DownButton.png"));

        JButton RightButton = new JButton(new ImageIcon(RightIcon));
        JButton LeftButton = new JButton(new ImageIcon(LeftIcon));
        JButton UpButton = new JButton(new ImageIcon(UpIcon));
        JButton DownButton = new JButton(new ImageIcon(DownIcon));
        JButton CreateButton = new JButton("Создать");

        CreateButton.setBounds(12, 401, 90, 40);
        RightButton.setBounds(840,411,30,30);
        LeftButton.setBounds(768,411,30,30);
        UpButton.setBounds(804,375,30,30);
        DownButton.setBounds(804,411,30,30);

        TankPanel.add(CreateButton);
        TankPanel.add(RightButton);
        TankPanel.add(LeftButton);
        TankPanel.add(UpButton);
        TankPanel.add(DownButton);
        TankFrame.add(TankPanel, BorderLayout.CENTER);

        Random random = new Random();
        CreateButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                DrawningTank.Init(random.nextInt(300 - 100 + 1) + 100, random.nextDouble() * (3000 - 1000) + 1000,
                        Color.getHSBColor(random.nextInt(302), random.nextInt(302), random.nextInt(302)),
                        Color.getHSBColor(random.nextInt(302), random.nextInt(302), random.nextInt(302)),
                        random.nextInt(6 - 4 + 1) + 4,  TankPanel.getWidth(), TankPanel.getHeight(),
                        random.nextBoolean(), random.nextBoolean(), TankPanel);
                DrawningTank.SetPosition(random.nextInt(100 - 10 + 1) + 10, random.nextInt(100 - 10 + 1) + 10);
                DrawningTank.DrawTank();
            }
        });

        RightButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if (DrawningTank.EntityTank() == null)
                    return;
                DrawningTank.MoveTransport(DirectionType.Right);
                DrawningTank.DrawTank();
            }
        });

        LeftButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if (DrawningTank.EntityTank() == null)
                    return;
                DrawningTank.MoveTransport(DirectionType.Left);
                DrawningTank.DrawTank();
            }
        });

        UpButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if (DrawningTank.EntityTank() == null)
                    return;
                DrawningTank.MoveTransport(DirectionType.Up);
                DrawningTank.DrawTank();
            }
        });

        DownButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if (DrawningTank.EntityTank() == null)
                    return;
                DrawningTank.MoveTransport(DirectionType.Down);
                DrawningTank.DrawTank();
            }
        });

        TankFrame.setVisible(true);
    }
}
